# Create your views here.
from models import *
from django.http import HttpResponse
from ships import models
import json
from django.shortcuts import render_to_response
from django.db.models import Q
from django.template import RequestContext

def translate(request, model, field):
    start = request.GET.get("start", False)
    end = request.GET.get("end", False)
    if not start and not end:
        limit = False
    else:
        limit = True
    try:
        m = models.__getattribute__(model)
    except AttributeError:
        return HttpResponse("no such model")
    response = []
    if field not in m._meta.get_all_field_names():
        return HttpResponse("no such field")
    qset = m.objects.values(field).distinct()
    if limit:
        if not start:
            start = 0
        if not end:
            end = qset.count()
        qset = qset[start:end]
    for obj in qset:
        val = obj[field]
        ordArr = []
        isEnglish = True
        for char in val:
            # unichr is the opposite of ord
            charOrd = ord(char)
            if (charOrd > 500):
                isEnglish = False
            ordArr.append(str(ord(char)))
        if not isEnglish:
            response.append({
                'ord': ordArr.join(","),
		'val': val
            })
    context = RequestContext(request, {
        'values': response,
        'model': model,
        'field': field
    })
    return render_to_response("translate.html", context)

def dotranslate(request, model, field):
    txt = request.POST.get('txt', '')
    lines = txt.split("\n\n")
    trans_field = field + "_trans"
    m = models.__getattribute__(model)
    savedArr = []
    for line in lines:
        split = line.split("|")
        ordArr = split[0].join(",")
        val = split[1]
        oldVal = [unichr(v) for v in ordArr].join("")
        q = Q(**{"%s__isequal" % field: val})
        matches = m.objects.filter(q)
        savedArr.append("%s: %s" % (oldVal, val,))
        for m in matches:
            m[trans_field] = val
            m.save()
    return HttpResponse(savedArr.join("\n"))
